package com.vendor.burn.ui.burners;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.Messages;
import com.vendor.burn.model.FileSystem;
import com.vendor.burn.model.FlashType;
import com.vendor.burn.model.PartitionItem;
import com.vendor.burn.model.devices.unknown.UnknownDevice;
import com.vendor.burn.serial.workers.WorkerUtility;
import com.vendor.burn.ui.burners.PartitionComposite;
import java.io.File;
import java.io.IOException;
import java.util.List;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ICellModifier;
import org.eclipse.swt.widgets.TableItem;

class null implements ICellModifier {
  public boolean canModify(Object element, String property) {
    PartitionItem value = null;
    if (element instanceof PartitionItem) {
      value = (PartitionItem)element;
    } else if (element instanceof TableItem) {
      value = (PartitionItem)((TableItem)element).getData();
    } 
    String chipName = ((UnknownDevice)PartitionComposite.access$800(PartitionComposite.this).getBurnContext().getDeviceSetting()).getName();
    return PartitionComposite.this.isCanModify(property, value, chipName);
  }
  
  public Object getValue(Object element, String property) {
    PartitionItem value = null;
    if (element instanceof PartitionItem) {
      value = (PartitionItem)element;
    } else if (element instanceof TableItem) {
      value = (PartitionItem)((TableItem)element).getData();
    } 
    if (value != null) {
      if (property.equals(PartitionComposite.COLUMNS[1])) {
        String name = value.getName();
        return (name == null) ? "" : name;
      } 
      if (property.equals(PartitionComposite.COLUMNS[2])) {
        File file = value.getFile();
        try {
          return (file != null) ? file.getCanonicalPath() : "";
        } catch (IOException e) {
          return "";
        } 
      } 
      if (property.equals(PartitionComposite.COLUMNS[3])) {
        FlashType flashType = value.getFlashType();
        String[] items = PartitionComposite.this.flashTypeEditor.getItems();
        for (int i = 0; i < items.length; i++) {
          String name = items[i];
          if (name.equals("spi nand/nand")) {
            name = FlashType.nand.name();
          } else if (name.equals("spi nor")) {
            name = FlashType.spi.name();
          } 
          if (name.equals(flashType.name()))
            return Integer.valueOf(i); 
        } 
        return Integer.valueOf(0);
      } 
      if (property.equals(PartitionComposite.COLUMNS[4])) {
        String[] items = PartitionComposite.this.fileSystemEditor.getItems();
        for (int i = 0; i < items.length; i++) {
          if (items[i].equals(value.getFileSystem().name()))
            return Integer.valueOf(i); 
        } 
        return Integer.valueOf(0);
      } 
      if (property.equals(PartitionComposite.COLUMNS[5]))
        return WorkerUtility.ReceiveHelper.convertUnit(value.getStart()); 
      if (property.equals(PartitionComposite.COLUMNS[6])) {
        long length = value.getLength();
        if (length == -1L)
          return "-"; 
        return WorkerUtility.ReceiveHelper.convertUnit(length);
      } 
    } 
    return value;
  }
  
  public void modify(Object element, String property, Object value) {
    PartitionItem item = null;
    if (element instanceof PartitionItem) {
      item = (PartitionItem)element;
    } else if (element instanceof TableItem) {
      item = (PartitionItem)((TableItem)element).getData();
    } 
    if (item != null)
      if (property.equals(PartitionComposite.COLUMNS[1])) {
        if (item.getName() == null || 
          !item.getName().equals(value)) {
          item.setName((String)value);
          PartitionComposite.this.isDirty = true;
        } 
      } else if (property.equals(PartitionComposite.COLUMNS[2])) {
        String valueStr = (String)value;
        if (valueStr == null || valueStr.isEmpty()) {
          if (item.getFile() != null) {
            PartitionComposite.this.isDirty = true;
            item.setFile(null);
          } 
        } else {
          try {
            if (item.getFile() == null || 
              !item.getFile().getCanonicalPath().equalsIgnoreCase(valueStr)) {
              File file = new File(valueStr);
              item.setFile(file);
              updateFileSystem(item, file);
              PartitionComposite.this.isDirty = true;
            } else {
              File file = item.getFile();
              updateFileSystem(item, file);
            } 
          } catch (IOException e) {
            return;
          } 
        } 
      } else if (property.equals(PartitionComposite.COLUMNS[3])) {
        Integer index = (Integer)value;
        if (index.intValue() == -1)
          index = Integer.valueOf(0); 
        String string = PartitionComposite.this.flashTypeEditor.getItems()[index.intValue()];
        if (string.equals("spi nand/nand")) {
          string = FlashType.nand.name();
        } else if (string.equals("spi nor")) {
          string = FlashType.spi.name();
        } 
        FlashType oldValue = item.getFlashType();
        if (oldValue != FlashType.valueOf(string)) {
          item.setFlashType(FlashType.valueOf(string));
          PartitionComposite.this.updateFlashTypeAddress(item, oldValue);
          PartitionComposite.this.isDirty = true;
        } 
      } else if (property.equals(PartitionComposite.COLUMNS[4])) {
        Integer index = (Integer)value;
        if (index.intValue() == -1)
          index = Integer.valueOf(0); 
        String string = PartitionComposite.this.fileSystemEditor.getItems()[index.intValue()];
        FileSystem oldValue = item.getFileSystem();
        FileSystem valueOf = FileSystem.valueOf(string);
        if (oldValue != valueOf) {
          item.setFileSystem(valueOf);
          PartitionComposite.this.isDirty = true;
        } 
      } else if (property.equals(PartitionComposite.COLUMNS[5])) {
        long convertToNumber;
        String valueStr = (String)value;
        if (valueStr.equals("")) {
          convertToNumber = 0L;
        } else {
          convertToNumber = WorkerUtility.ReceiveHelper.convertToNumber(valueStr);
          if (convertToNumber % 512L != 0L) {
            MessageDialog.openWarning(PartitionComposite.this.getShell(), Messages.FASTBOOT_WARNING_Title, Messages.PartitionComposite_InvalidUnit);
            PartitionComposite.this.updateAddresses(item);
            return;
          } 
        } 
        if (convertToNumber != item.getStart()) {
          item.setStart(convertToNumber);
          PartitionComposite.this.updateAddresses(item);
          PartitionComposite.this.isDirty = true;
        } 
      } else if (property.equals(PartitionComposite.COLUMNS[6])) {
        String valueStr = (String)value;
        if (valueStr.equals("")) {
          long convertToNumber = 0L;
        } else {
          List<PartitionItem> children = PartitionComposite.this.getBurner().getPratitionInfo().getChildren();
          if (valueStr.equals("-") && (PartitionComposite.this
            .getBurner() instanceof com.vendor.burn.model.devices.burners.EmmcBurner || PartitionComposite.this.getBurner() instanceof com.vendor.burn.model.devices.burners.PartitionBurner) && children
            .size() > 0 && children
            .get(children.size() - 1) == item) {
            PartitionComposite.this.isDirty = false;
            if (item.getLength() != -1L) {
              item.setLength(-1L);
              PartitionComposite.this.itemViewer.refresh(item);
              PartitionComposite.this.updateAddresses(item);
            } 
          } else {
            long convertToNumber = WorkerUtility.ReceiveHelper.convertToNumber(valueStr);
            if (convertToNumber % 512L != 0L) {
              MessageDialog.openWarning(PartitionComposite.this
                  .getShell(), Messages.FASTBOOT_WARNING_Title, Messages.partitionLengthShouldBeWithUnitKorMor512Times);
            } else if (item.getLength() != convertToNumber) {
              item.setLength(convertToNumber);
              PartitionComposite.this.isDirty = true;
              PartitionComposite.this.updateAddresses(item);
            } 
          } 
        } 
      }  
    PartitionComposite.this.viewer.refresh();
    PartitionComposite.this.promptToSave(false);
  }
  
  private void updateFileSystem(PartitionItem item, File file) {
    String fileName = file.getName();
    if (fileName.toLowerCase().endsWith(".ext3") || fileName
      .toLowerCase().endsWith(".ext4")) {
      String[] systemItems = PartitionComposite.this.fileSystemEditor.getItems();
      for (int systemIndex = 0; systemIndex < systemItems.length; systemIndex++) {
        String systemItem = systemItems[systemIndex];
        if (systemItem.equalsIgnoreCase("ext3/4")) {
          item.setFileSystem(FileSystem.ext3);
          PartitionComposite.this.isDirty = true;
          break;
        } 
      } 
    } 
    if (fileName.toLowerCase().endsWith(".yaffs") || fileName
      .toLowerCase().endsWith(".yaffs2")) {
      String[] systemItems = PartitionComposite.this.fileSystemEditor.getItems();
      for (int systemIndex = 0; systemIndex < systemItems.length; systemIndex++) {
        String systemItem = systemItems[systemIndex];
        if (systemItem.equalsIgnoreCase("yaffs")) {
          item.setFileSystem(FileSystem.yaffs);
          PartitionComposite.this.isDirty = true;
          break;
        } 
      } 
    } 
    if (fileName.toLowerCase().endsWith(".ubi")) {
      String[] systemItems = PartitionComposite.this.fileSystemEditor.getItems();
      for (int systemIndex = 0; systemIndex < systemItems.length; systemIndex++) {
        String systemItem = systemItems[systemIndex];
        if (systemItem.equalsIgnoreCase("ubifs")) {
          item.setFileSystem(FileSystem.ubiFs);
          PartitionComposite.this.isDirty = true;
          break;
        } 
      } 
    } 
    if (fileName.toLowerCase().endsWith(".squashfs")) {
      String[] systemItems = PartitionComposite.this.fileSystemEditor.getItems();
      for (int systemIndex = 0; systemIndex < systemItems.length; systemIndex++) {
        String systemItem = systemItems[systemIndex];
        if (systemItem.equalsIgnoreCase("squashfs")) {
          item.setFileSystem(FileSystem.squashFs);
          PartitionComposite.this.isDirty = true;
          break;
        } 
      } 
    } 
  }
}
